"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
function _export(target, all) {
  for (var name in all)
    Object.defineProperty(target, name, {
      enumerable: true,
      get: all[name]
    });
}
_export(exports, {
  nodeResolvePath: function() {
    return nodeResolvePath;
  },
  isRelativePath: function() {
    return isRelativePath;
  },
  toPosixPath: function() {
    return toPosixPath;
  },
  toLocalPath: function() {
    return toLocalPath;
  },
  stripExtension: function() {
    return stripExtension;
  },
  replaceExtension: function() {
    return replaceExtension;
  },
  matchesPattern: function() {
    return matchesPattern;
  },
  isImportCall: function() {
    return isImportCall;
  },
  escapeRegExp: function() {
    return escapeRegExp;
  }
});
const _interop_require_default = require("@swc/helpers/_/_interop_require_default");
const _path = /* @__PURE__ */ _interop_require_default._(require("path"));
const _resolve = /* @__PURE__ */ _interop_require_default._(require("resolve"));
function nodeResolvePath(modulePath, basedir, extensions) {
  try {
    return _resolve.default.sync(modulePath, {
      basedir,
      extensions
    });
  } catch (e) {
    return null;
  }
}
function isRelativePath(nodePath) {
  return nodePath.match(/^\.?\.\//);
}
function toPosixPath(modulePath) {
  return modulePath.replace(/\\/g, "/");
}
function toLocalPath(modulePath) {
  let localPath = modulePath.replace(/\/index$/, "");
  if (!isRelativePath(localPath)) {
    localPath = `./${localPath}`;
  }
  return localPath;
}
function stripExtension(modulePath, stripExtensions) {
  let name = _path.default.basename(modulePath);
  stripExtensions.some((extension) => {
    if (name.endsWith(extension)) {
      name = name.slice(0, name.length - extension.length);
      return true;
    }
    return false;
  });
  return name;
}
function replaceExtension(modulePath, opts) {
  const filename = stripExtension(modulePath, opts.stripExtensions);
  return _path.default.join(_path.default.dirname(modulePath), filename);
}
function matchesPattern(types, calleePath, pattern) {
  const { node } = calleePath;
  if (types.isMemberExpression(node)) {
    return calleePath.matchesPattern(pattern);
  }
  if (!types.isIdentifier(node) || pattern.includes(".")) {
    return false;
  }
  const name = pattern.split(".")[0];
  return node.name === name;
}
function isImportCall(types, calleePath) {
  return types.isImport(calleePath.node.callee);
}
function escapeRegExp(string) {
  return string.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
}
